<?

	class CPanel_API
	{
		private $host = '';
		private $user = '';
		private $pass = '';
		
		private $port = 2086;
		private $ssl = FALSE;
		
		private $url = '';
		
		public function init($params=array())
		{
			if(isset($params['host']) && $params['host'] != '') $this->host = $params['host'];
			else return false;
			
			if(isset($params['user']) && $params['user'] != '') $this->user = $params['user'];
			else return false;
			
			if(isset($params['pass']) && $params['pass'] != '') $this->pass = $params['pass'];
			else return false;
			
			if(isset($params['port']) && $params['port'] != '') $this->port = $params['port'];
			if(isset($params['ssl']) && $params['ssl'] != '') $this->ssl = $params['ssl'];
			
			if($this->ssl) $this->url = 'https';
			else $this->url = 'http';
			
			$this->url.= '://'.$this->host.':'.$this->port;

			return true;
		}
		
		public function create_account($domain, $user, $pass, $email, $package)
		{
			$params[] = 'username='.$user;
			$params[] = 'plan='.$package;
			$params[] = 'password='.$pass;
			$params[] = 'contactemail='.$email;
			$params[] = 'domain='.$domain;
			
			return $this->query('/xml-api/createacct?'.implode('&', $params));
		}
		
		public function delete_account($user)
		{
			return $this->query('/xml-api/removeacct?user='.$user);			
		}
		
		public function suspend_account($user)
		{
			return $this->query('/xml-api/suspendacct?user='.$user);
		}
		
		public function unsuspend_account($user)
		{
			return $this->query('/xml-api/unsuspendacct?user='.$user);
		}
		
		public function change_package($user, $package)
		{
			return $this->query('/xml-api/changepackage?user='.$user.'&pkg='.$package);
		}
		
		public function change_password($user, $password)
		{
			return $this->query('/xml-api/passwd?user='.$user.'&pass='.$password);
		}		
		
		public function bandwidth($user, $limit)
		{			
			return $this->query('/xml-api/limitbw?user='.$user.'&bwlimit='.$limit);
		}
		
		private function query($query = NULL)
		{
			if(!empty($query))
			{
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, $this->url.$query);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				
				curl_setopt($ch, CURLOPT_USERPWD, $this->user.':'.$this->pass);
				curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);

				$result = curl_exec($ch);
				curl_close($ch);
				
				return $result;
			}
			
			return FALSE;
		}
	}

?>